using System;
using static System.Console;

// Arithmetic expressions with single-digit numbers and parenthesized operators

abstract class Expr {
}

class ConstExpr : Expr {
  int val;
  
  public ConstExpr(int val) { this.val = val; }
}

class OpExpr : Expr {
  char op;
  Expr left, right;
  
  public OpExpr(Expr left, char op, Expr right) {
    this.left = left; this.op = op; this.right = right;
  }
}

class Parser {
  static char read() => (char) Read();
  
  public static Expr parse() {
    char c = read();
    
    if (char.IsDigit(c))
      return new ConstExpr(c - '0');
      
    if (c == '(') {
      Expr left = parse();
      char op = read();
      Expr right = parse();
      if (read() != ')')
        throw new Exception("expected ')'");
        
      return new OpExpr(left, op, right);
    }
    
    throw new Exception("syntax error");
  }
}

class Arith {
  static void Main() {
    Expr e = Parser.parse();
  }
}
